#pragma once
#include "AlgorithmIdentifier.h"
//======================================================================
//	FIPS Pub 197	AES		Encoder / Decorder
//----------------------------------------------------------------------
//  Reference:
//	RFC 3565		Use of the Advanced Encryption Standard (AES) Encryption
//					Algorithm in Cryptographic Message Syntax (CMS)
//======================================================================
//
//	{vÓA`drÍSIMD߁iSSE2jŏ鎖
//	ׂ݂ɊJ܂B̒mIɂYłB
//
//	botA`drÍׂSIMDiAVXj
//	ǉ邻łAȑObotڂĂob
//	SIMD߂ɂÍE݂镨łB
//	"SSE2"ɑΉĂCPUł΁A삷͂łB
//
//	A{NXA\[XR[h̗pۂ́A񂭂B
//	A{NXA\[XR[h̗pɂ蔭Ȃ
//	Qɂ܂Ă͖@eőɂĐӔC𕉂܂̂ŁA
//	gp҂̐ӔČAp΍KłB
//
//	ǵAb++̃\[XǂłB
//	"main.c"́A{NX"AES"̎gp@̃TvxɂlB
//
//						Copyright (c) A.Watanabe (2010)
//
//----------------------------------------------------------------------
//	Revision
//		2010.12.27	
//		2010.12.28	啔AZuiMASMĵA
//					b++ŏB
//======================================================================
union _mm_i8
{
	__declspec(align(16))	unsigned	char	i8[16];
							__m128i				m128i;
};
union _mm_i16
{
	__declspec(align(16))	unsigned	__int16	i16[8];
							__m128i				m128i;
};
union _mm_i32
{
	__declspec(align(16))	unsigned	int		i32[4];
							__m128i				m128i;
};
/****************************************************************/
/*			萔`											*/
/****************************************************************/
#define		AES_Nb			4			//Number of columns (32-bit words) comprising the State.
										//For this standard, Nb = 4. (Also see Sec. 6.3.)
#define		AES_Nbb			AES_Nb*4	//[Byte]
#define		AES_BlockSize	AES_Nbb
/****************************************************************/
/*			vg^Cv錾									*/
/****************************************************************/
//AZuŏꂽ֐	"AES_sse.asm"
extern "C"{
				__m128i	__fastcall	AES_SSE_Cipher(unsigned char cNr,unsigned int *ptrKs, __m128i data);
				__m128i	__fastcall	AES_SSE_InvCipher(unsigned char cNr,unsigned int *ptrKs, __m128i data);
//	unsigned	int		__fastcall	SubWord(unsigned int data);
//	unsigned	int		__fastcall	SubWord2(unsigned int data);
//	unsigned	int		__fastcall	SubWord3(unsigned int data);
//	unsigned	int		__fastcall	InvSubWord(unsigned int data);
}

/****************************************************************/
/*			NX`											*/
/****************************************************************/
class __declspec(align(16)) AES :
	public AlgorithmIdentifier
{
//Variable
public:
	__declspec(align(16)) unsigned	int	w[60];	//Key Schedule	(16byte align)

	__m128i				vector;

	static	unsigned	int		oid[];	//	= (2,16,840,1,101,3,4,1,cMode);
	OctetString			IV;
	enum				useMode{ECB, CBC, OFB, CFB, CTR, CTS}	mode;

	unsigned	char	Nk;					//Number of 32-bit words comprising the Cipher Key.
											//For this standard, Nk = 4, 6, or 8. (Also see Sec. 6.3.)
	unsigned	char	Nr;					//Number of rounds, which is a function of Nk and Nb (which is fixed).
											//For this standard, Nr = 10, 12, or 14. (Also see Sec. 6.3.)

//Function
public:
	AES(const char _strName[]="AES");											//
	~AES(void);										//

	int		Check_OID(ObjectIdentifier* ptOID);
	void	Set_AES(int	cMode, __m128i _xmm_IV);

	void	Set_Key(void *key){KeyExpansion((unsigned char *)key);};
	void	Clear_Key();										//Zero
	void	init(){SetIV();};									//
	void	encrypt(void *data);								//Í
	void	decrypt(void *data);								//

private:
	void		SetIV();
	unsigned	int		RotWord(unsigned int data);				//
	unsigned	int		SubWord(unsigned int data);				//
	unsigned	int		SubWord2(unsigned int data);			//(x 02)
	unsigned	int		SubWord3(unsigned int data);			//(x 03)
	unsigned	int		InvSubWord(unsigned int data);			//

	__m128i	mul(__m128i data, unsigned char n);					//4,2	Multiplication

	void	Cipher_One(void *ind, void *outd);					//
	__m128i	Cipher(__m128i data);								//5.1	Cipher
	__m128i	SubBytes(__m128i data);								//5.1.1	SubBytes
	__m128i	SubBytes2(__m128i data);							//5.1.1	SubBytes(x02)
	__m128i	SubBytes3(__m128i data);							//5.1.1	SubBytes(x03)
	__m128i	ShiftRows(__m128i data);							//5.1.2	ShiftRows
	__m128i	MixColumns(__m128i data);							//5.1.3	MixColumns
	__m128i	AddRoundKey(__m128i data, int i);					//5.1.4	AddRoundKey

	void	KeyExpansion(unsigned char *key);					//5.2	Key Expansion

	void	InvCipher_One(void *ind, void *outd);				//
	__m128i	InvCipher(__m128i data);							//5.3	InvCipher
	__m128i	InvShiftRows(__m128i data);							//5.3.1	InvShiftRows
	__m128i	InvSubBytes(__m128i data);							//5.3.2	InvSubBytes
	__m128i	InvMixColumns(__m128i data);						//5.3.3	InvMixColumns
	__m128i	InvAddRoundKey(__m128i data, int i);				//5.3.4	InvAddRoundKey

	void	CBC_Cipher(void *data);
	void	CBC_InvCipher(void *data);
};
