#include "StdAfx.h"
#include "HMAC.h"

//==============================================================
//			RXgN^
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
HMAC::HMAC(Digest* _cHash):
	AlgorithmIdentifier("HMAC"),
	cHash(_cHash)
{
	//vZp̃obt@m
	Kipad		= new char[cHash->szBlock];
	Kopad		= new char[cHash->szBlock + cHash->szHash];
}
//==============================================================
//			fXgN^
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
HMAC::~HMAC(void)
{
	//vZp̃obt@J
	delete	Kipad;
	delete	Kopad;
}
//==============================================================
//			̃Zbg
//--------------------------------------------------------------
//	
//		void*				Key		
//		unsigned	int		szKey	̃TCY
//	Ԓl
//			
//	l
//			PBKDF2ŁÂ͖ʂ̈
//==============================================================
void	HMAC::SetKey(void* Key, unsigned int szKey)
{
	//pxɃANZX̂ŁAWX^ɓB
			Digest*			_cHash	=	cHash;				//nbV֐̃|C^
	const	unsigned	int	szBlock =	_cHash->szBlock;	//nbV֐̓̓ubN
	const	unsigned	int	szHash	=	_cHash->szHash;		//nbV֐̏o͒
			char*			_Kipad	=	Kipad;				//œKŃWX^ɓĖႤB
			char*			_Kopad	=	Kopad;				//

	//------------
	//0x00Padding
	{
		//ϐ`
		const	char*	cKey			= (char *)Key;

		//Padding{
		if(szKey > szBlock){
			_cHash->CalcHash(_Kipad, Key, szKey);
			szKey = szHash;
			memcpy((char*)_Kopad,(char*)_Kipad,szKey);
		} else {
			memcpy(_Kipad,Key,szKey);
			memcpy(_Kopad,Key,szKey);
		}
		memset(&_Kipad[szKey],0x00,szBlock - szKey);
		memset(&_Kopad[szKey],0x00,szBlock - szKey);
	}

	//------------
	//ipad  opad ŔrI_a쐬
	{
		//ϐ`
				unsigned	int		i	=	0;
		static	const	_mm_i32	_mm_36	= {0x36363636,0x36363636,0x36363636,0x36363636};
		static	const	_mm_i32	_mm_5C	= {0x5C5C5C5C,0x5C5C5C5C,0x5C5C5C5C,0x5C5C5C5C};
						__m128i _mm_temp;	

		//rI_a{
		while((i + sizeof(__m128i)) < szBlock){
			_mm_storeu_si128((__m128i*)_Kipad, _mm_xor_si128(_mm_loadu_si128((__m128i*)_Kipad) ,_mm_36.m128i));
			_mm_storeu_si128((__m128i*)_Kopad, _mm_xor_si128(_mm_loadu_si128((__m128i*)_Kopad) ,_mm_5C.m128i));
			_Kipad += sizeof(__m128i);
			_Kopad += sizeof(__m128i);
			i += sizeof(__m128i);
		}
		i = szBlock - i;
		_mm_temp	= _mm_xor_si128(_mm_loadu_si128((__m128i*)_Kipad) ,_mm_36.m128i);
		memcpy(_Kipad, &_mm_temp, i);
		_mm_temp	= _mm_xor_si128(_mm_loadu_si128((__m128i*)_Kopad) ,_mm_5C.m128i);
		memcpy(_Kopad, &_mm_temp, i);
	}
}
//==============================================================
//			vZ
//--------------------------------------------------------------
//	
//		void*				result	
//		void*				data	bZ[W
//		unsigned	int		szData	bZ[W̃TCY
//	Ԓl
//			
//==============================================================
void	HMAC::calc(void* result, void* data, unsigned int szData)
{
			unsigned	int		i	=	szData;

	//pxɃANZX̂ŁAWX^ɓB
			Digest*			_cHash	=	cHash;				//nbV֐̃|C^
	const	unsigned	int	szBlock =	_cHash->szBlock;	//nbV֐̓̓ubN
	const	unsigned	int	szHash	=	_cHash->szHash;		//nbV֐̏o͒

	//------------
	//vZ
	{
		//ϐ`
		char*	cData	= (char *)data;

		//1st PASS
		_cHash->init();
		_cHash->add(Kipad);
		while(i>0){
			if(i>=szBlock){
				_cHash->add(cData);
				cData += szBlock;
				i -= szBlock;
			} else {
				_cHash->final(cData,i);
				break;
			}
		}
		_cHash->getHash(&Kopad[szBlock]);

		//2nd PASS
		_cHash->CalcHash(result, Kopad, szBlock + szHash);
	}
}
