#include "stdafx.h"
#include "mt.h"

//==============================================================
//		
//--------------------------------------------------------------
//	
//		
//	Ԓl
//			
//==============================================================
MT::MT():
	mti(MT_N+1)
{
	//Default seed	X^eBbN̈ɒuBiX^bNɒumov߂4fBj
	static	unsigned	long	init[4]	=	{0x123, 0x234, 0x345, 0x456};

	init_by_array(init, 4);
}
//==============================================================
//		
//--------------------------------------------------------------
//	
//		unsigned long init_key[]	
//		unsigned int key_length		̐
//	Ԓl
//			
//==============================================================
MT::MT(unsigned long init_key[], unsigned int key_length):
	mti(MT_N+1)
{
	init_by_array(init_key, key_length);
}
//==============================================================
//		initializes mt[N] with a seed
//--------------------------------------------------------------
//	
//		unsigned	long	s		
//	Ԓl
//			
//==============================================================
void MT::init_genrand(unsigned long s)
{

	unsigned	int	iMT = 0;	//UWX^ɓB

	mt[iMT++] = s & 0xffffffffUL;

	do{
	//	__asm	prefetchnta	mt[iMT+8]
		_mm_prefetch((const char *)&mt[iMT+4], 0);	//߂̔zAL1LbVɃtFb`ĂB
		_mm_prefetch((const char *)&mt[iMT+8], 1);	//낻̂AL2LbVɃtFb`ĂB

		//gȂŁAWX^[ŌvZB
		//ϐ"s"ɂ́A mt[iMT-1]ĂB
		s = ((unsigned long)1812433253 * (s ^ (s >> 30)) + iMT) & 0xffffffffUL;
	
		//zϐւ݂̏́Ä񂾂ɁB
		mt[iMT++] = s;

	} while (iMT < MT_N);

	mti = iMT;
}

//==============================================================
//		initialize by an array with array-length
//		init_key is the array for initializing keys
//		key_length is its length
//		slight change for C++, 2004/2/26
//--------------------------------------------------------------
//	
//		unsigned long init_key[]	
//		unsigned int key_length		̐
//	Ԓl
//		
//==============================================================
void MT::init_by_array(unsigned long init_key[], unsigned int key_length)
{

	//̕ӂ́AWX^[ϐɂȂĂB
	unsigned	int		iMT		= 0;	
	unsigned	int		iKey	= 0;	
	unsigned	int		k		= ((MT_N>key_length)? MT_N : key_length);
	unsigned	long	r;		//result

	init_genrand(19650218UL);

	r = mt[iMT++];		//[vł̃ǂݍ݂𖳂ׁAœǂłB
						//xANZXƁÃLbVR/WׁB

	while(k--){
	//	__asm	prefetchnta	mt[iMT+8]
		_mm_prefetch((const char *)&mt[iMT+4], 0);	//߂̔zAL1LbVɃtFb`ĂB
	//	_mm_prefetch((const char *)&mt[iMT+8], 1);	//낻̂AL2LbVɃtFb`ĂB

		//gȂŁAWX^[ŌvZB
		//ϐ"r"ɂ́A mt[iMT-1]ĂB
		r = ((mt[iMT] ^ ((r ^ (r >> 30)) * (unsigned long)1664525)) + init_key[iKey] + iKey) & 0xffffffffUL;

		//zϐւ݂̏́Ä񂾂ɁB
		mt[iMT++] = r;

		if (iMT>=MT_N){
			iMT=1;
//			mt[iMT++] = r;		//ϐ"r"ɓĂ̂ŗvȂ
		}
		iKey++;
		if(iKey>=key_length){iKey=0;}
	};

	k = MT_N-1;
	while(k--){
	//	__asm	prefetchnta	mt[iMT+8]
		_mm_prefetch((const char *)&mt[iMT+4], 0);	//߂̔zAL1LbVɃtFb`ĂB
	//	_mm_prefetch((const char *)&mt[iMT+8], 1);	//낻̂AL2LbVɃtFb`ĂB

		//gȂŁAWX^[ŌvZB
		//ϐ"r"ɂ́A mt[iMT-1]ĂB
		r = ((mt[iMT] ^ ((r ^ (r >> 30)) * (unsigned long)1566083941)) - iMT) & 0xffffffffUL;

		mt[iMT++] = r;		//zւ̏݁B
        if (iMT>=MT_N){
			iMT=1;
//			mt[iMT++] = r;		//ϐ"r"ɓĂ̂ŗvȂ
		}
	};

	mt[0] = 0x80000000UL; /* MSB is 1; assuring non-zero initial array */ 

}

//==============================================================
//		generates a random number on [0,0xffffffff]-interval
//--------------------------------------------------------------
//	
//		
//	Ԓl
//		unsigned long		
//==============================================================
unsigned long MT::genrand_int32(void)
{

	unsigned	int		iMT = mti;	//UWX^ɓB
	unsigned	long	y;
	unsigned	long	n;

	if(iMT >= MT_N){

		if(iMT >= MT_N+1){		//ĂȂAB
			init_genrand(5489);
		}

		iMT		= 0;
		n		= mt[iMT];
		do{
			y = (n & UPPER_MASK);
			n = mt[iMT+1];			//̒lƂĎgB
			y |= (n & LOWER_MASK);
			mt[iMT] = (mt[iMT+MT_M]) ^ ((y)&1UL ? MATRIX_A : 0) ^ (y >> 1);
			iMT++;
		} while (iMT < MT_N-MT_M);

		do{
			y = (n & UPPER_MASK);
			n = mt[iMT+1];			//̒lƂĎgB
			y |= (n & LOWER_MASK);
			mt[iMT] = (mt[iMT+MT_M-MT_N]) ^ ((y)&1UL ? MATRIX_A : 0) ^ (y >> 1);
			iMT++;
		} while (iMT < MT_N-1);

			y = (n & UPPER_MASK) | (mt[0] & LOWER_MASK);
			mt[MT_N-1] = (mt[MT_M-1]) ^ ((y)&1UL ? MATRIX_A : 0) ^ (y >> 1);
			iMT = 0;
	}

    /* Tempering */
	y	= mt[iMT++];
	mti	= iMT;

	y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}
