#include "StdAfx.h"
#include "PBKDF2.h"

unsigned	int		PBKDF2::oid[] = {1,2,840,113549,1,5,12};

//==============================================================
//			RXgN^
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
PBKDF2::PBKDF2(HMAC* _cHMAC):
	AlgorithmIdentifier("PBKDF2"),
	cHMAC(_cHMAC)
{
	//JԂvZpobt@
	hLen		= cHMAC->cHash->szHash;
	U_			= (unsigned	char*)_aligned_malloc(hLen, sizeof(__m128i));

	//rI_ai[obt@
	__m128_hLen	= (hLen/sizeof(__m128i)) + 1;
	__m128_U	= (__m128i*)_aligned_malloc(__m128_hLen * sizeof(__m128i), sizeof(__m128i));
}
//==============================================================
//			fXgN^
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
PBKDF2::~PBKDF2(void)
{
	_aligned_free(__m128_U);
	_aligned_free(U_);
}
//==============================================================
//			ݒ
//--------------------------------------------------------------
//	
//		void*				_S		\g
//		unsigned	int		_szS	\g̃TCY
//		unsigned	int		_c		JԂ
//		unsigned	int		_dkLen	o錮̃TCY
//	Ԓl
//			
//==============================================================
void	PBKDF2::Set_PBKDF2(void* _S, unsigned int _szS, unsigned int _c, unsigned int _dkLen)
{
	//ASN.1̒`
	Set(oid,sizeof(oid)/sizeof(int));

	//salt specified OCTET STRING,
	US	= (unsigned	char*)_aligned_malloc(_szS + sizeof(int), sizeof(__m128i));
	memcpy(US, _S, _szS);
	S.assign((char *)_S, _szS);
	salt.Set((char *)_S, _szS);
	parameters.Set_Construct(&salt);

	//iterationCount INTEGER (1..MAX),
	c		= _c;
	iterationCount.Set(_c);
	parameters.Set_Construct(&iterationCount);

	//keyLength INTEGER (1..MAX) OPTIONAL,
	dkLen	= _dkLen;
	keyLength.Set(_dkLen);
	parameters.Set_Construct(&keyLength);

	//prf AlgorithmIdentifier
	parameters.Set_Construct(cHMAC);

	Set_Construct(&parameters);
}
//==============================================================
//			vZ
//--------------------------------------------------------------
//	
//		void*				T	vZʂi[|C^
//		unsigned	int		szT	i[TCY
//		void*				P	pX[h
//		unsigned	int		szP	pX[h̃TCY
//		unsigned	int		n	
//	Ԓl
//			
//==============================================================
void	PBKDF2::F(void* T, unsigned int szT, unsigned int n)
{
	unsigned	int		cnt			= c;
	unsigned	int		_m128_hLen	= __m128_hLen;
			__m128i*	_m128_U		= __m128_U;
	unsigned	char*	_U_			= U_;

	//------
	//1 times
	{
		unsigned	int		sLen		= S.size();
		unsigned	int*	USi			= (unsigned int *)&US[sLen];	//

		USi[0] = ((n>>24) & 0xFF) | ((n>>8) & 0xFF00) | ((n & 0xFF00)<<8) | ((n & 0xFF)<<24);
		cHMAC->calc(_U_, US, sLen+4);
		for(unsigned int i = 0; i < _m128_hLen; i++){
			_m128_U[i] = _mm_load_si128((__m128i*)&_U_[i * sizeof(__m128i)]);
		}
		cnt--;
	}

	//------
	//2 times -
	{
		unsigned	int		_hLen		= hLen;

		while(cnt--){
			cHMAC->calc(_U_, _U_, _hLen);
			for(unsigned int i = 0; i < _m128_hLen; i++){
				_m128_U[i] = _mm_xor_si128(_m128_U[i] ,_mm_load_si128((__m128i*)&_U_[i * sizeof(__m128i)]));
			}
		}
	}

	//------
	//vZʊi[
	{
		unsigned	char*	U	=	(unsigned	char*)T;			//߂li[|C^
		unsigned	int		i	=	0;

		while((i + sizeof(__m128i)) <= szT){
			_mm_storeu_si128((__m128i*)&U[i], _m128_U[i / sizeof(__m128i)]);
			i += sizeof(__m128i);
		}
		memcpy(&U[i], &_m128_U[i / sizeof(__m128i)], szT - i);
	}
}
//==============================================================
//			vZ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
void	PBKDF2::calc(void* DK, void* P, unsigned int szP)
{
	//ɁAHMAC֐̌vZB
	cHMAC->SetKey(P, szP);

	//vZ
	{
		unsigned	int		i		= 0;
		unsigned	int		_hLen	= hLen;
		unsigned	int		l		= dkLen / _hLen;
		unsigned	int		r		= dkLen % _hLen;
		unsigned	char*	T		= (unsigned	char*)DK;

		while(l--){
			i++;
			F(T, _hLen, i);	//ʂ𒼐ړB
			T += _hLen;
		}
		if(r > 0){
			i++;
			F(T, r, i);
		}
	}
}
