#pragma once
#include "AlgorithmIdentifier.h"

//======================================================================
//				PBKDF2: Password-Based Key Derivation Function 2
//----------------------------------------------------------------------
//  Reference:
//	RFC 2898		PKCS #5: Password-Based Cryptography Specification
//	RFC 6070		Password-Based Key Derivation Function 2 (PBKDF2) Test Vectors
//======================================================================
//
//	{vÓAPBKDF2ZoNXłB
//
//						Copyright (c) A.Watanabe (2011)
//
//----------------------------------------------------------------------
//	Revision
//		2011. 4.
//======================================================================
/****************************************************************/
/*			萔`											*/
/****************************************************************/



/****************************************************************/
/*			NX`											*/
/****************************************************************/
class PBKDF2 :
	public AlgorithmIdentifier
{
//--------------
//ϐ
	HMAC*						cHMAC;		//nbV֐
			string				S;			//Tg
			unsigned	int		c;			//JԂ
			unsigned	int		dkLen;		//

			//JԂvZpobt@
			unsigned	int		hLen;
			unsigned	char*	U_;

			unsigned	char*	US;

			//rI_ai[obt@
			unsigned	int		__m128_hLen;
					__m128i*	__m128_U;

			//ASN.1p
	static	unsigned	int		oid[];		//	= {1.2.840.113549.1.5.12};

			Sequence			parameters;
			OctetString			salt;
			Integer				iterationCount;
			Integer				keyLength;		//option
			AlgorithmIdentifier	prf;


//--------------
//֐
public:
	PBKDF2(HMAC* _cHash);
	~PBKDF2(void);

	void	Set_PBKDF2(void* _S, unsigned int _szS, unsigned int _c, unsigned int _dkLen);

	void	F(void* T, unsigned int szT, unsigned int n);
	void	calc(void* DK, void* P, unsigned int szP);
};
